classification
Title: subprocess: _close_open_fd_range_safe() does not set close-on-exec flag on Linux < 2.6.23 if O_CLOEXEC is defined
Type: Stage:
Components: Versions: Python 3.4, Python 3.3, Python 3.2
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: gregory.p.smith Nosy List: gregory.p.smith, haypo, neologix
Priority: normal Keywords:

Created on 2013-01-12 14:54 by haypo, last changed 2013-08-27 23:25 by haypo. This issue is now closed.

Messages (3)
msg179803 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2013-01-12 14:54
The following extract of _close_open_fd_range_safe() is not correct:

#ifdef O_CLOEXEC
    fd_dir_fd = open(FD_DIR, O_RDONLY | O_CLOEXEC, 0);
#else
    fd_dir_fd = open(FD_DIR, O_RDONLY, 0);
#ifdef FD_CLOEXEC
    {
        int old = fcntl(fd_dir_fd, F_GETFD);
        if (old != -1)
            fcntl(fd_dir_fd, F_SETFD, old | FD_CLOEXEC);
    }
#endif
#endif

On Linux older than 2.6.23, O_CLOEXEC may be defined by the glibc whereas the kernel does not support it. In this case, the flag is simply ignored and close-on-exec flag is not set on the file descriptor.
msg180910 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2013-01-29 15:17
This issue is fixed in my implementation of the PEP 433: see #17036.
msg196332 - (view) Author: STINNER Victor (haypo) * (Python committer) Date: 2013-08-27 23:25
This issue has been fixed in the implementation of the PEP 446 (issue #18571).
History
Date User Action Args
2013-08-27 23:25:04hayposetstatus: open -> closed
resolution: fixed
messages: + msg196332
2013-01-29 15:17:03hayposetmessages: + msg180910
2013-01-13 07:07:07gregory.p.smithsetassignee: gregory.p.smith
nosy: + gregory.p.smith, - gps
2013-01-12 15:10:33r.david.murraysetnosy: + gps
2013-01-12 14:54:13haypocreate